// YUSB.cpp: CYUSB NX̃Cve[V
// VUSB tTvR[h hiddata.c bpNX
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "YTaskBarLaunch.h"
#include "YUSB.h"

//#include "../firm/usbconfig.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// \z/
//////////////////////////////////////////////////////////////////////

CYUSB::CYUSB()
{
	// ֐̃[h
	hModule = LoadLibrary( "HID.DLL" );
	if(hModule == NULL) return;

	HidD_GetHidGuid = (HIDD_GETHIDGUID*)GetProcAddress( hModule, "HidD_GetHidGuid" );
	HidD_GetAttributes = (HIDD_GETATTRIBUTES*)GetProcAddress( hModule, "HidD_GetAttributes" );
	HidD_GetFeature = (HIDD_GETFEATURE*)GetProcAddress( hModule, "HidD_GetFeature" );
	HidD_SetFeature = (HIDD_SETFEATURE*)GetProcAddress( hModule, "HidD_SetFeature" );

	HidD_GetProductString = (HIDD_GETPRODUCTSTRING*)GetProcAddress( hModule, "HidD_GetProductString" );
	HidD_GetManufacturerString = (HIDD_GETMANUFACTURERSTRING*)GetProcAddress( hModule, "HidD_GetManufacturerString" );

	m_device = 0;
}

CYUSB::~CYUSB()
{
	CloseDevice();
	if(hModule == NULL) return;
	FreeLibrary(hModule);
}

static void hexdump(char *buffer, int len)
{
int     i;
char outbuf[2048], outtext[2048];
	outtext[0] = '\0';

    for(i = 0; i < len; i++){
        if(i != 0){
            if(i % 16 == 0){
                sprintf(outbuf, "\n");
            }else{
                sprintf(outbuf, " ");
            }
			strcat(outtext, outbuf);
        }
        sprintf(outbuf, "0x%02x", buffer[i] & 0xff);
			strcat(outtext, outbuf);
    }
    if(i != 0){
        sprintf(outbuf, "\n");
			strcat(outtext, outbuf);
	}
	
	MessageBox(NULL, outtext, "", MB_OK);
}

void CYUSB::Test()
{
	int ret;

	// Open Device
	unsigned char   rawVid[2] = {USB_CFG_VENDOR_ID}, rawPid[2] = {USB_CFG_DEVICE_ID};
	int vid = rawVid[0] + 256 * rawVid[1];
	int pid = rawPid[0] + 256 * rawPid[1];
	HANDLE device;
	ret = HidOpenDevice(&device, vid, pid, 0, NULL, NULL);
	if(ret!=0) {
		MessageBox(NULL, "Error", "Error", MB_OK);
		return;
	}

	// Read Device
	char buffer[1+USB_REPORT_SIZE];
	int len = sizeof(buffer);
	ret = HidGetReport(device, 0, buffer, &len);
	if(ret != 0){
		MessageBox(NULL, "Error", "Error", MB_OK);
	}else{
            hexdump(buffer + 1, sizeof(buffer) - 1);
	}

	HidCloseDevice(device);
	return;
}
void CYUSB::SendTest2(int state)
{
	int ret;

	// Open Device
	unsigned char   rawVid[2] = {USB_CFG_VENDOR_ID}, rawPid[2] = {USB_CFG_DEVICE_ID};
	char     vendorName[] = {USB_CFG_VENDOR_NAME, 0}, productName[] = {USB_CFG_DEVICE_NAME, 0};
	int vid = rawVid[0] + 256 * rawVid[1];
	int pid = rawPid[0] + 256 * rawPid[1];
	HANDLE device;
	ret = HidOpenDevice(&device, vid, pid, 0, vendorName, productName);
	if(ret!=0) {
		DebugMsg("Error: USB device cannot open!(%d)", ret);
		return;
	}

	// Write Device
	char buffer[1+USB_REPORT_SIZE];
	int len = sizeof(buffer);
	buffer[0] = 0; // dummy report ID
	buffer[1] = (char)state;
	ret = HidSetReport(device, buffer, len);
	if(ret != 0){
		DebugMsg("Error: SetReport(%d) ", ret);
	}
/*
	// Read Device
	ret = HidGetReport(device, 0, buffer, &len);
	if(ret != 0){
		MessageBox(NULL, "Error: GetReport() ", "Error", MB_OK);
	}else{
            hexdump(buffer + 1, sizeof(buffer) - 1);
	}
*/
	HidCloseDevice(device);
	return;
}


int CYUSB::HidOpenDevice(HANDLE *device, int vendorID, int productID, int usesReportIDs, char* vendorName, char* productName)
{
	GUID                                hidGuid;        /* GUID for HID driver */
	HDEVINFO                            deviceInfoList;
	SP_DEVICE_INTERFACE_DATA            deviceInfo;
	SP_DEVICE_INTERFACE_DETAIL_DATA     *deviceDetails = NULL;
	DWORD                               size;
	int                                 i, openFlag = 0;  /* may be FILE_FLAG_OVERLAPPED */
	int                                 errorCode = USBOPEN_ERR_NOTFOUND;
	HANDLE                              handle = INVALID_HANDLE_VALUE;
	HIDD_ATTRIBUTES                     deviceAttributes;

	if(hModule == NULL) return USBOPEN_ERR_DLL_NOTFOUND;

    HidD_GetHidGuid(&hidGuid);
    deviceInfoList = SetupDiGetClassDevs(&hidGuid, NULL, NULL, DIGCF_PRESENT | DIGCF_INTERFACEDEVICE);
    deviceInfo.cbSize = sizeof(deviceInfo);
    for(i=0;;i++){
        if(handle != INVALID_HANDLE_VALUE){
            CloseHandle(handle);
            handle = INVALID_HANDLE_VALUE;
        }
        if(!SetupDiEnumDeviceInterfaces(deviceInfoList, 0, &hidGuid, i, &deviceInfo))
            break;  /* no more entries */
        /* first do a dummy call just to determine the actual size required */
        SetupDiGetDeviceInterfaceDetail(deviceInfoList, &deviceInfo, NULL, 0, &size, NULL);
        if(deviceDetails != NULL){
            free(deviceDetails);
		}
        deviceDetails = (SP_DEVICE_INTERFACE_DETAIL_DATA*) malloc(size);
        deviceDetails->cbSize = sizeof(*deviceDetails);
        /* this call is for real: */
        SetupDiGetDeviceInterfaceDetail(deviceInfoList, &deviceInfo, deviceDetails, size, &size, NULL);
        DEBUG_PRINT(("checking HID path \"%s\"\n", deviceDetails->DevicePath));

        /* attempt opening for R/W -- we don't care about devices which can't be accessed */
        handle = CreateFile(deviceDetails->DevicePath, GENERIC_READ|GENERIC_WRITE, FILE_SHARE_READ|FILE_SHARE_WRITE, NULL, OPEN_EXISTING, openFlag, NULL);
        if(handle == INVALID_HANDLE_VALUE){
            DEBUG_PRINT(("opening failed: %d\n", (int)GetLastError()));
            /* errorCode = USBOPEN_ERR_ACCESS; opening will always fail for mouse -- ignore */
            continue;
        }
        deviceAttributes.Size = sizeof(deviceAttributes);
        HidD_GetAttributes(handle, &deviceAttributes);
        DEBUG_PRINT(("device attributes: vid=%d pid=%d\n", deviceAttributes.VendorID, deviceAttributes.ProductID));
        if(deviceAttributes.VendorID != vendorID || deviceAttributes.ProductID != productID)
            continue;   /* ignore this device */
        errorCode = USBOPEN_ERR_NOTFOUND;
		
        if(vendorName != NULL && productName != NULL){
            char    buffer[512];
            if(!HidD_GetManufacturerString(handle, buffer, sizeof(buffer))){
                DEBUG_PRINT(("error obtaining vendor name\n"));
                errorCode = USBOPEN_ERR_IO;
                continue;
            }
            convertUniToAscii(buffer);
            DEBUG_PRINT(("vendorName = \"%s\"\n", buffer));
            if(strcmp(vendorName, buffer) != 0)
                continue;
            if(!HidD_GetProductString(handle, buffer, sizeof(buffer))){
                DEBUG_PRINT(("error obtaining product name\n"));
                errorCode = USBOPEN_ERR_IO;
                continue;
            }
            convertUniToAscii(buffer);
            DEBUG_PRINT(("productName = \"%s\"\n", buffer));
            if(strcmp(productName, buffer) != 0)
                continue;
        }
		
        break;  /* we have found the device we are looking for! */
    }
    SetupDiDestroyDeviceInfoList(deviceInfoList);
    if(deviceDetails != NULL)
        free(deviceDetails);
    if(handle != INVALID_HANDLE_VALUE){
        *device = handle;
        errorCode = 0;
    }
    return errorCode;
}

void CYUSB::HidCloseDevice(HANDLE device)
{
    CloseHandle((HANDLE)device);
}

int CYUSB::HidSetReport(HANDLE device, char *buffer, int len)
{
	BOOLEAN rval;
	if(hModule == NULL) return USBOPEN_ERR_DLL_NOTFOUND;

    rval = HidD_SetFeature((HANDLE)device, buffer, len);
    return rval == 0 ? USBOPEN_ERR_IO : 0;
}

int CYUSB::HidGetReport(HANDLE device, int reportNumber, char *buffer, int *len)
{

	if(hModule == NULL) return USBOPEN_ERR_DLL_NOTFOUND;
	BOOLEAN rval = 0;

    buffer[0] = reportNumber;
    rval = HidD_GetFeature((HANDLE)device, buffer, *len);
    return rval == 0 ? USBOPEN_ERR_IO : 0;
}

void CYUSB::convertUniToAscii(char *buffer)
{
	unsigned short  *uni = (unsigned short *)buffer;
	char            *ascii = buffer;

    while(*uni != 0){
        if(*uni >= 256){
            *ascii++ = '?';
        }else{
            *ascii++ = (char)*uni++;
        }
    }
    *ascii++ = 0;
}

/* ----------------------- C^tF[X ------------------------ */

int CYUSB::OpenDevice()
{
	if(m_device) CloseDevice();
	
	int ret;
	// Open Device
	unsigned char   rawVid[2] = {USB_CFG_VENDOR_ID}, rawPid[2] = {USB_CFG_DEVICE_ID};
	char     vendorName[] = {USB_CFG_VENDOR_NAME, 0}, productName[] = {USB_CFG_DEVICE_NAME, 0};
	int vid = rawVid[0] + 256 * rawVid[1];
	int pid = rawPid[0] + 256 * rawPid[1];
	ret = HidOpenDevice(&m_device, vid, pid, 0, vendorName, productName);

	return ret;
}

int CYUSB::CloseDevice()
{
	if(m_device == 0) return -1;

	HidCloseDevice((HANDLE)m_device);
	return 0;
}

int CYUSB::SendReport(char *buffer, int len)
{
	if(m_device == 0) return -1;

	return HidSetReport(m_device, buffer, len);
}

int CYUSB::GetReport(char *buffer, int len)
{
	if(m_device == 0) return -1;

	return HidGetReport(m_device, 0, buffer, &len);
}

BOOL CYUSB::DeviceIsOpen()
{
	if(m_device) return TRUE;
	else return FALSE;
}


